/*
 * io_devctl2.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <devctl.h>
#include <sys/neutrino.h>
#include <sys/iofunc.h>

#define DCMD_AUDIO_SET_SAMPLE_RATE			1
#define DCMD_AUDIO_GET_SAMPLE_RATE			2

int
io_devctl (resmgr_context_t *ctp, io_devctl_t *msg, iofunc_ocb_t *ocb)
{
    int     sts;
    void	*data;
    int     nbytes;

    if ((sts = iofunc_devctl_default (ctp, msg, ocb)) != _RESMGR_DEFAULT) {
        return (sts);
    }

    // 1) assign a pointer to the data area of the message
    data = _DEVCTL_DATA (*msg);

    // 2) preset the number of bytes that we'll return to zero
    nbytes = 0;

    // check for all commands, we'll just show the ones we're interested in here
    switch (msg -> i.dcmd) {
    // 3) process the SET command
    case    DCMD_AUDIO_SET_SAMPLE_RATE:
        audio_set_samplerate (* (int *) data);
        break;

    // 4) process the GET command
    case    DCMD_AUDIO_GET_SAMPLE_RATE:
        * (int *) data = audio_get_samplerate ();
        nbytes = sizeof (int);
        break;
    }

    // 5) return data (if any) to the client
    memset (&msg -> o, 0, sizeof (msg -> o));
    msg -> o.nbytes = nbytes;
    SETIOV (ctp -> iov, &msg -> o, sizeof (msg -> o) + nbytes);
    return (_RESMGR_NPARTS (1));
}
